*Example do file for use of US state and county spatial contiguity matrix.
*US state level

clear
set memory 50m
cd "S:/ScottM/swm/"
use "us48_spatial_weight.dta", clear
keep v*

save "weight1.dta" ,replace
spatwmat using weight1, n(W)

use "D:\DATA\maps\us-database.dta" 
sort fips
save, replace

use "state_summary_of_business04.dta", clear
destring state, gen(fips)
sort fips
merge fips using "D:\DATA\maps\us-database.dta" 

drop if state == "15" | state == "02" | fips == 11
drop  name- _merge

spatwmat, n(D) x(x) y(y) band(0 500000) binary

spatgsa indem_acre, w(W) moran gear go
spatgsa indem_acre, w(D) moran gear go

spatlsa indem_acre, w(W) moran

*Note:  Change line 282 of -spatlsa- matrix column name from "p-value" to "pvalue" 
matrix A =r(Moran)

svmat A , n(col)

format z %3.2f

tmap chor z, id(id) map("D:\DATA\maps\us48-coordinates.dta") palette(Blues) /// 
legs(1.25) clm(custom) clb(-1.5 0 1  2.5) title("Local Spatial Correlation") /// 
subtitle("Moran's I z-values") addplot(label z, x(x) y(y)) /// 
note("Positive z-values indicate positive spatial correlation")

*
*Iowa counties
*

use "usc_spatial_weight.dta", clear
keep if state == "19"
levels fips, local(levels)
foreach l of local levels {
	local keep "`keep' v`l'"
}
keep fips `keep'

sort fips
drop fips

save "weight2.dta" ,replace
spatwmat using weight2, n(W)

use "summary_of_business04.dta", clear
merge state county using "D:\DATA\maps\uscounty_fips.dta" 
keep if state == "19"

gen indem_acre = indemnity/net_acre

spatgsa indem_acre, w(W) moran gear go
spatlsa indem_acre, w(W) moran

matrix A =r(Moran)

svmat A , n(col)

format z %5.2f

tmap chor z , id(_ID) map("D:\DATA\maps\uscounty.dta") palette(Paired) /// 
legs(1.25) clm(custom) clb(-6 -2 0 2  11) title("Local Spatial Correlation") /// 
subtitle("Moran's I z-values") addplot(label z, y(latitude) x(longitude)) /// 
note("Positive z-values indicate positive spatial correlation")
 